#include <gtk/gtk.h>
#include "common.h"
#include <sys/types.h>
#include <signal.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdio.h>
#include "init_file.h"

void play_file (int nummer);
void pause_file ();
void stop_file ();
void ffwd_file ();
void rewind_file ();
void scroll_file (float time);

float seconds_total;
int freeze;

void play_file (int nummer)
{
	GdkColor black;
	GdkColor red;
	struct mp3info *temp;

	black.red=0;
	black.green=0;
	black.blue=0;
	red.red=65535;
	red.green=0;
	red.blue=0;

	if (play_status == PAUSED) 
	{
		pause_file();
		return;
	}
	if (playlistlength == 0) return;
	if (nummer >= playlistlength) nummer = 0;
	temp  = gtk_clist_get_row_data (GTK_CLIST(playlist), nummer);

	gtk_clist_set_foreground (GTK_CLIST(playlist), now_playing, &black); 
	gtk_clist_set_foreground (GTK_CLIST(playlist), nummer, &red); 
	
	now_playing = nummer;

	play_status = PLAYING;
	execute (nummer,0);
	gtk_entry_set_text(GTK_ENTRY(text_info), temp->songname);
	seconds_total = temp->seconds;
}

void pause_file ()
{
	if (play_status == PAUSED)
	{
		kill (pid,18);
		play_status = PLAYING;
	}
	else if (play_status == PLAYING)
	{
		kill (pid,19);	
		play_status = PAUSED;
	}
}

void stop_file ()
{
	if (play_status != STOPPED)
	{
		kill (pid,18);
		kill (pid,15);
		waitpid (pid, 0,0);
		pid = 0;
		play_status = STOPPED;
	}
}

void ffwd_file ()
{
	int volgende;
	if (play_status == PAUSED) stop_file();

	volgende = now_playing +1;
	if (volgende >= playlistlength) volgende = 0;
	play_file (volgende);
}

void rewind_file()
{
	if (play_status == PAUSED) stop_file();
	if (now_playing == 0) 
	{
		play_file (playlistlength-1);
	}
	else 
	{
		play_file (now_playing -1);
	}
}

void scroll_file (float time)
{
	if (freeze == 1) return;
	if (playlistlength == 0) return;
	execute (now_playing,time);
	play_status = PLAYING;
}
